//sidearmSniper - extrude

/////////
//Audio//
/////////

datablock AudioProfile(sidearmSniperShot)
{
	filename = "./intervention.wav";
	description = AudioClose3d;
	preload = true;
};

datablock ParticleData(sidearmSniperSmokeParticle)
{
	dragCoefficient      = 4;
	gravityCoefficient   = -1.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 425;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.7";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.05;
	sizes[1]      = 0.25;

	useInvAlpha = false;
};

datablock ParticleEmitterData(sidearmSniperSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sidearmSniperSmokeParticle";
};

AddDamageType("sidearmSniper",   '<bitmap:add-ons/Weapon_sidearmSniper/generic> %1',    '%2 <bitmap:add-ons/Weapon_sidearmSniper/generic> %1',0.2,1);
datablock ProjectileData(sidearmSniperProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 75;
   directDamageType    = $DamageType::sidearmSniper;
   radiusDamageType    = $DamageType::sidearmSniper;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = gunExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 150;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 2.0;
   lightColor  = "0 0 0.5";

   uiName = "Sniper Shot";
};

AddDamageType("gunSide",   '<bitmap:add-ons/Weapon_gun/ci_gun> %1',    '%2 <bitmap:add-ons/Weapon_gun/ci_gun> %1',0.2,1);
datablock ProjectileData(handgunProjectile2)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 8;
   directDamageType    = $DamageType::sidearmSniper;
   radiusDamageType    = $DamageType::sidearmSniper;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = gunExplosion;
   particleEmitter     = "";

   muzzleVelocity      = 150;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 1500;
   fadeDelay           = 750;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 2.0;
   lightColor  = "0 0 0.5";

   uiName = "Handgun Shot";
};

//////////
// item //
//////////
datablock ItemData(sidearmSniperItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Intervention.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Sidearm Sniper";
	iconName = "./Icon_sidearmSniper";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = sidearmSniperImage;
	canDrop = true;


};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(sidearmSniperImage)
{
   // Basic Item properties
   shapeFile = "./Intervention.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.0 1.0 -0.85"
   rotation = ""; //eulerToMatrix( "0 0 0" )

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = sidearmSniperProjectile;
   projectileType = Projectile;

	casing = GunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   LarmReady = true;

   doColorShift = true;
   colorShiftColor = sidearmSniperItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateSequence[0]		= "lock";
	stateTimeoutValue[0]            = 0.5;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]					= weaponSwitchSound;
	
	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]				= "ready";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= gunFlashEmitter;
	stateEmitterTime[3]				= 0.10;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= sidearmSniperShot;

	stateName[4] 					= "Smoke";
	stateEmitter[4]					= sidearmSniperSmokeEmitter;
	stateEmitterTime[4]				= 0.14;
	stateEmitterNode[4]				= "muzzleNode";
	stateSequence[4]			= "Load";
	stateTimeoutValue[4]            = 1.75;
	stateEjectShell[4]       		= true;
	stateTransitionOnTimeout[4]     = "Ready";
	
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(sidearmSniperImage2)
{
   // Basic Item properties
   shapeFile = "add-ons/Weapon_Gun/pistol.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0 0 0";
   rotation = ""; //eulerToMatrix( "0 0 0" )

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = handgunProjectile2;
   projectileType = Projectile;

	casing = GunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   LarmReady = true;

   doColorShift = true;
   colorShiftColor = sidearmSniperItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateSequence[0]		= "lock";
	stateTimeoutValue[0]            = 0.01;
	stateTransitionOnTimeout[0]     = "Ready";
	stateSound[0]					= weaponSwitchSound;
	
	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]				= "ready";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "Smoke";
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= gunFlashEmitter;
	stateEmitterTime[3]				= 0.10;
	stateEmitterNode[3]				= "muzzleNode";
	stateSound[3]					= gunShot1Sound;
		stateEjectShell[3]       		= true;

	stateName[4] 					= "Smoke";
	stateEmitter[4]					= sidearmSniperSmokeEmitter;
	stateEmitterTime[4]				= 0.14;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0.4;

	stateTransitionOnTimeout[4]     = "Ready";
	
};

function sidearmSniperImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}

function sidearmSniperImage2::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}

package imageSwitch2
{
	 function Armor::onTrigger(%this,%obj,%slot,%val)
	 {
		 Parent::onTrigger(%this,%obj,%slot,%val);
		 if(%slot == 4 && %val)
		 {
			 if(%obj.getMountedImage(0) == sidearmSniperImage.getID())
			 {
				 %obj.updateArm(sidearmSniperImage2);
				 %obj.mountImage(sidearmSniperImage2,0);
			 }
			 else if(%obj.getMountedImage(0) == sidearmSniperImage2.getID())
			 {
				 %obj.updateArm(sidearmSniperImage2);
				 %obj.mountImage(sidearmSniperImage,0);
			 }
		 }
	 }
};
activatePackage(imageSwitch2);
